//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   m_hTGTWnd=0;
   m_SrJPG = new _SrJPG(this);
   m_strFnPt.OnMtrPlay = this->fnOnMtrPlay;
   m_strFnPt.OnDeCmpr = this->fnOnDeCmprProgess;
   m_strFnPt.OnCmpr = this->fnOnCmprProgess;
   m_strFnPt.OnDeCmprFinish = this->fnOnDeCmprFinish;
   m_strFnPt.OnCmprFinish = this->fnOnCmprFinish;
   m_SrJPG->fnSetInterFace(m_strFnPt);

   m_Mtr = new _ImgMatrix();
 
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   delete m_SrJPG;
   delete m_Mtr;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::fnOnCmprFinish()
{
   ProgressBar2->Tag=0;
   ProgressBar2->Position=0;
}
//-------------------------------------
void __fastcall TForm1::fnOnDeCmprFinish()
{
   ProgressBar1->Tag=0;
   ProgressBar1->Position=0;
}
//-----------------------------------------------------------------------------
void __fastcall TForm1::fnOnCmprProgess(TObject *Sender)
{
   ProgressBar2->Tag++;
   ProgressBar2->Position = ProgressBar2->Tag%ProgressBar2->Max;
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::fnOnDeCmprProgess(TObject *Sender)
{
   ProgressBar1->Tag++;
   ProgressBar1->Position = ProgressBar1->Tag%ProgressBar1->Max;
   Application->ProcessMessages();
}
//----------------------------------------------------------------------------
void __fastcall TForm1::fnOnMtrPlay(_ImgMatrix *Mtr, int iColLen, int iRowLen, float fRate)
{
   Mtr->fnSetDisplayPnl(Panel5);

   Button5->Caption  ="Play Rate="+FloatToStrF(fRate, ffFixed, 3,1);
}
//------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
   Button7Click(Button7);
   m_SrJPG->fnSetCompressionLevel(RadioGroup1->ItemIndex);
   m_SrJPG->fnSetFilter(LabeledEdit5->Text.ToIntDef(20));
   m_SrJPG->fnSetCompressionQuality(LabeledEdit1->Text.ToIntDef(50));
   m_SrJPG->fnSetRecordFrame(LabeledEdit2->Text.ToIntDef(15));
   m_SrJPG->fnSetRecordColRow(LabeledEdit3->Text.ToIntDef(1), LabeledEdit4->Text.ToIntDef(1));
   m_SrJPG->fnRecording(m_hTGTWnd);

   Button9->Enabled=false;
   Button2->Enabled=true;
   Form1->WindowState = wsMinimized;
   
}
//-----------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   m_SrJPG->fnSaveVPG(FormatDateTime("YYMMDD_HHMMSS", Now() ));
   Button9->Enabled=true;
   Button2->Enabled=false;
}
//------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   if(!Button1->Tag){
      m_SrJPG->fnRecordingSpace(!Button1->Tag);
      Button1->Caption = "Running";
   }
   else{
      m_SrJPG->fnRecordingSpace(!Button1->Tag);
      Button1->Caption = "Pause";
   }
   Button1->Tag =!Button1->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   String ansFileName;
   if(!Button3->Tag){    //Load
      if(OpenDialog1->Execute())
         ansFileName=OpenDialog1->FileName;
      else return;

      m_headerR = m_SrJPG->fnLoadVPG(ansFileName);
      if(m_headerR.iHeadDataCnt)
         ScrollBar1->Max = (m_headerR.iHeadDataCnt/(m_headerR.iCo1Len*m_headerR.iRowLen)) -1;
      else  return;
      m_Mtr->fnInitMtr(m_headerR.iCo1Len, m_headerR.iRowLen);
      Panel5->Width   = m_headerR.iWidth;
      Panel5->Height  = m_headerR.iHeight;
      Label1->Caption = "ColLen, RowLen=("+IntToStr(m_headerR.iCo1Len)+","+IntToStr(m_headerR.iRowLen)+")";
      Label2->Caption = "W, H=("+IntToStr(m_headerR.iWidth)+","+IntToStr(m_headerR.iHeight)+")";
      Label3->Caption = "R/E Rate="+FloatToStrF(m_headerR.fRealFrameRate, ffFixed, 4,2)+"/"+IntToStr(m_headerR.iExpectFrameRate);
      Label4->Caption = "Push/Rec="+FloatToStrF(((float)m_headerR.iPushDataCnt)/((float)m_headerR.iHeadDataCnt), ffFixed, 5,2);
      Label5->Caption = "Avg ="+FloatToStrF(m_headerR.iVPGSize/(m_headerR.iPushDataCnt*1024.),  ffFixed, 5,1)+" KB";
      Label6->Caption = "Record Time="+FormatDateTime("HH:MM:SS.zzz", m_headerR.dAllTime);

      Button3->Caption="Release";
      Button5->Tag=0;
      Button5Click(Button5);
      Button5->Enabled=true;
      ScrollBar1->Position=0;
      m_SrJPG->fnSetVPGPos(0);
      ScrollBar2->Position=0;
   }
   else{
      if(m_SrJPG->fnReleaseVPG()){  //Release
         Label1->Caption = "";
         Label2->Caption = "";
         Label3->Caption = "";
         Label4->Caption = "";
         Label5->Caption = "";
         Label6->Caption = "";

         Button3->Caption="Load";
         Button5->Tag=1;
         
         Button5Click(Button5);
         Button5->Enabled=false;
      }
   }
   Button3->Tag = !Button3->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   this->DoubleBuffered=true;
   this->Panel5->DoubleBuffered=true;
   Edit1->Text = Form1->Caption;
   Button7Click(Button7);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
   if(!Button5->Tag){
      Button5->Caption = "Stop";
   }
   else{
      Button5->Caption = "Resume Play";
   }
   m_SrJPG->fnPlaySpace(Button5->Tag);
   Button5->Tag =!Button5->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
   m_SrJPG->fnSetVPGPos(ScrollBar1->Position*m_headerR.iCo1Len*m_headerR.iRowLen);
}
//--------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
   float fRate;
   if(ScrollBar2->Position >0)
      fRate = 1+(ScrollBar2->Position/10.);
   else if(ScrollBar2->Position <0 )
      fRate = -(10./ScrollBar2->Position);
   else
      fRate = 1.0;
   m_SrJPG->fnSetPlayRate(fRate);
}
//-----------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
   RECT rt;
   String ansRt;
   m_hTGTWnd = FindWindow(NULL,Edit1->Text.c_str());
   if(IsWindow(m_hTGTWnd)){
      GetWindowRect(m_hTGTWnd, &rt);
      ansRt = IntToStr(rt.left)+","+IntToStr(rt.top)+"("+IntToStr(abs(rt.right-rt.left))+"*"+IntToStr(abs(rt.bottom-rt.top))+")";
      Button7->Caption=ansRt;
   }
   else{
      Button7->Caption="no Get";
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar3Change(TObject *Sender)
{
/*
   int iCol, iRow, iCCLen, iCRLen;
   iCol=ScrollBar3->Position;
   iRow=ScrollBar4->Position;
   iCCLen=ScrollBar5->Position;
   iCRLen=ScrollBar6->Position;
   m_Mtr->fnCombineImg(Image1, iCol, iRow, iCCLen, iCRLen);
   */
   float fSclx, fScly;
   if(ScrollBar3->Position >0)
      fSclx = 1.+((ScrollBar3->Position)/10.);
   else if(ScrollBar3->Position <0 )
      fSclx = 1+(0.05*ScrollBar3->Position);
   else
      fSclx = 1.0;

   if(ScrollBar4->Position >0)
      fScly = 1.+((ScrollBar4->Position)/10.);
   else if(ScrollBar4->Position <0 )
      fScly = 1+(0.05*ScrollBar4->Position);
   else
      fScly = 1.0;
   m_SrJPG->fnSetPlayScl(fSclx, fScly);
   Panel5->Width   = m_headerR.iWidth*fSclx;
   Panel5->Height  = m_headerR.iHeight*fScly;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
    Button7Click(Button7);
}
//---------------------------------------------------------------------------


